package esame1402;

import java.util.*;
import java.io.*;

public class Srotola
{
	BufferedReader br = null;
	Stack stack = null;

	public Srotola(BufferedReader theBr)
	{
		br = theBr;
		stack = new Stack();
	}

	public LinkedList execute() throws IOException
	{
		LinkedList retval = new LinkedList();
		String linea = null;
		Persona p = null;
		while( (linea = br.readLine()) != null)
		{
			if(linea.equals("INIZIO"))//inizio nuovo cluster
			{
				System.out.println("NUOVO CLUSTER");
				p = new Persona();
				stack.push(p);
				p.nome = br.readLine();
				System.out.println(p.nome);
				p.cf = br.readLine();
				System.out.println(p.cf);
			}
			else if(linea.equals("FINE")) // fine cluster
			{
				System.out.println("FINE CLUSTER");
				p = (Persona)stack.pop();
				System.out.println(p.records.toString());
				retval.addAll(p.records);
				try
				{
					p = (Persona)stack.peek();
				}
				catch(EmptyStackException ese)
				{
					p = null;
					// la prossima linea puo' solo essere un nuovo cluster
				}
			}
			else // leggo un record
			{
				System.out.println("RECORD");
				String tipo = linea;
				if(tipo.equals("incidente"))
				{
					Incidente m = new Incidente(p.nome, p.cf, br);
					p.records.add(m);
				}
				else if(tipo.equals("riposo"))
				{
					//System.out.println(p.toString());
					Riposo r = new Riposo(p.nome, p.cf, br);
					p.records.add(r);
				}
				else
				{
					System.err.println("<" + tipo + "> IGNOTO!");
					System.exit(1);
				}
				System.out.println("FINE RECORD");
			}
		}
		return retval;
	}

	public void ordinaEStampa(LinkedList l)
	{
		Collections.sort(l, new ComparaRecords());
		System.out.println("\n\n\n" + l.toString());
	}

	public static void main(String[] argv) throws IOException
	{
		BufferedReader theBr = new BufferedReader(new FileReader("records.txt"));
		Srotola s = new Srotola(theBr);
		s.ordinaEStampa(s.execute());
		theBr.close();
	}
}
